
/* scanner for a toy Pascal-like language */

%{
#include "scanner.tab.h"

#include "llist.h"
#include <stdio.h>

extern UINT32 fporigcount;
extern FILE *fporig;

static inline
greg_printf(char *string, int len)
{
	fputs(string, fporig);
	fporigcount += len;
}

static inline
greg_printc(char c)
{
	fputc(c, fporig);
	fporigcount++;
}

%}

CHAR	[!-~]

SPC	[ ]
TAB	[	]
CR	[\r]
LF	[\n]

%%

[<]B>		{ greg_printf(yytext, 3); return TOK_B_START; }
[<][/]B>	{ greg_printf(yytext, 4); return TOK_B_END; }

[<]EM>		{ greg_printf(yytext, 4); return TOK_EM_START; }
[<][/]EM>	{ greg_printf(yytext, 5); return TOK_EM_END; }

[<]I>		{ greg_printf(yytext, 3); return TOK_I_START; }
[<][/]I>	{ greg_printf(yytext, 4); return TOK_I_END; }

[<]PL>		{ greg_printf(yytext, 4); return TOK_PL_START; }
[<][/]PL>	{ greg_printf(yytext, 5); return TOK_PL_END; }

[<]S>		{ greg_printf(yytext, 3); return TOK_S_START; }
[<][/]S>	{ greg_printf(yytext, 4); return TOK_S_END; }

[<]TT>		{ greg_printf(yytext, 4); return TOK_TT_START; }
[<][/]TT>	{ greg_printf(yytext, 5); return TOK_TT_END; }

[<]U>		{ greg_printf(yytext, 3); return TOK_U_START; }
[<][/]U>	{ greg_printf(yytext, 4); return TOK_U_END; }

[<]0>		{ greg_printf(yytext, 3); return TOK_0_START; }
[<][/]0>	{ greg_printf(yytext, 4); return TOK_0_END; }
[<]1>		{ greg_printf(yytext, 3); return TOK_1_START; }
[<][/]1>	{ greg_printf(yytext, 4); return TOK_1_END; }
[<]2>		{ greg_printf(yytext, 3); return TOK_2_START; }
[<][/]2>	{ greg_printf(yytext, 4); return TOK_2_END; }
[<]3>		{ greg_printf(yytext, 3); return TOK_3_START; }
[<][/]3>	{ greg_printf(yytext, 4); return TOK_3_END; }
[<]4>		{ greg_printf(yytext, 3); return TOK_4_START; }
[<][/]4>	{ greg_printf(yytext, 4); return TOK_4_END; }
[<]5>		{ greg_printf(yytext, 3); return TOK_5_START; }
[<][/]5>	{ greg_printf(yytext, 4); return TOK_5_END; }
[<]6>		{ greg_printf(yytext, 3); return TOK_6_START; }
[<][/]6>	{ greg_printf(yytext, 4); return TOK_6_END; }
[<]7>		{ greg_printf(yytext, 3); return TOK_7_START; }
[<][/]7>	{ greg_printf(yytext, 4); return TOK_7_END; }
[<]8>		{ greg_printf(yytext, 3); return TOK_8_START; }
[<][/]8>	{ greg_printf(yytext, 4); return TOK_8_END; }
[<]9>		{ greg_printf(yytext, 3); return TOK_9_START; }
[<][/]9>	{ greg_printf(yytext, 4); return TOK_9_END; }

[<]r>		{ greg_printf(yytext, 3); return TOK_r_START; }
[<][/]r>	{ greg_printf(yytext, 4); return TOK_r_END; }
[<]g>		{ greg_printf(yytext, 3); return TOK_g_START; }
[<][/]g>	{ greg_printf(yytext, 4); return TOK_g_END; }
[<]b>		{ greg_printf(yytext, 3); return TOK_b_START; }
[<][/]b>	{ greg_printf(yytext, 4); return TOK_b_END; }
[<]c>		{ greg_printf(yytext, 3); return TOK_c_START; }
[<][/]c>	{ greg_printf(yytext, 4); return TOK_c_END; }
[<]m>		{ greg_printf(yytext, 3); return TOK_m_START; }
[<][/]m>	{ greg_printf(yytext, 4); return TOK_m_END; }
[<]y>		{ greg_printf(yytext, 3); return TOK_y_START; }
[<][/]y>	{ greg_printf(yytext, 4); return TOK_y_END; }
[<]k>		{ greg_printf(yytext, 3); return TOK_k_START; }
[<][/]k>	{ greg_printf(yytext, 4); return TOK_k_END; }
[<]w>		{ greg_printf(yytext, 3); return TOK_w_START; }
[<][/]w>	{ greg_printf(yytext, 4); return TOK_w_END; }

{SPC}		{ yylval = *yytext; greg_printc(yylval); return TOK_SPC; }
{CR}		{ yylval = *yytext; greg_printc(yylval); return TOK_CR; }
{LF}		{ yylval = *yytext; greg_printc(yylval); return TOK_LF; }
{TAB}		{ yylval = *yytext; greg_printc(yylval); return TOK_TAB; }

{CHAR}		{ yylval = *yytext; greg_printc(yylval); return TOK_CHAR; }

.		printf( "Unrecognized character: %s\n", yytext );

%%


